Unit de51e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, II10E_p, ID10E_p, DE50E_p, UTDE11_p;

procedure de51e(F :Proc_F4E_DE; NX :Integer; XN :Extended; XK :Extended;
                var CN :Array of Extended; var CK :Array of Extended;
                EPS :Extended; var IMAX :Integer; IDER :Integer;
                var Y :Array of Extended; var IK :Integer;
                var DELTY :Array of Extended; var RAB :Array of Extended;
                var IERR :Integer);

implementation

procedure de51e(F :Proc_F4E_DE; NX :Integer; XN :Extended; XK :Extended;
                var CN :Array of Extended; var CK :Array of Extended;
                EPS :Extended; var IMAX :Integer; IDER :Integer;
                var Y :Array of Extended; var IK :Integer;
                var DELTY :Array of Extended; var RAB :Array of Extended;
                var IERR :Integer);
var
N5,NP,N,NP2,NP3,NP4,NP5,NP6,NP7,NP8,NP9,NP10,KA,KB,KB1,KC,KG,KD,KD1,
   KE,KE1,NUM1,KF,KF1,JUMP,LA,IER1 :Integer;
DX,Z,X :Extended;
BUL :Boolean;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20;
begin
IERR := 0;
BUL := False;
N5 := 0;
NP := NX;
N := NP-1;
NP2 := NP+NP;
NP3 := NP2+NP;
NP4 := NP3+NP;
NP5 := NP4+NP;
NP6 := NP5+NP;
NP7 := NP6+NP;
NP8 := NP4+NP4;
NP9 := NP8+NP;
NP10 := NP9+NP;
DX := (XK-XN)/(N);
JUMP := 13;
if ( IMAX ) < 0
 then goto _2
 else if ( IMAX ) > 0
       then goto _3
       else goto _1;
_1:
IERR := 67;
goto _20;
_2:
IMAX := -IMAX;
JUMP := 16;
_3:
for KA:=1 to IMAX do
 begin
  for KB:=1 to NP do
   begin
    KB1 := NP10+KB;
    RAB[KB1-1] := Y[KB-1];
_4:
   end;
  if ( IDER ) < 0
   then goto _5
   else if ( IDER ) > 0
         then goto _6
         else goto _8;
_5:
  IERR := 68;
  goto _20;
_6:
  for KC:=1 to NP do
   begin
    RAB[KC-1] := Y[KC-1];
_7:
   end;
  II10E(NP,1,1,NP,4,0,RAB);
  Z := 1/DX;
  RAB[NP5+0] := (RAB[NP+1]-0.5e0*RAB[NP2+1]+RAB[NP3+2]/3.e0-0.25e0*
    RAB[NP4+2])*Z;
  RAB[NP5+1] := (RAB[NP+2]-0.5e0*RAB[NP2+2]+RAB[NP3+3]/3.e0-0.25e0*
    RAB[NP4+3])*Z;
  RAB[NP6-2] := (RAB[NP2-2]+5.e0*RAB[NP3-3]+RAB[NP4-3]/3.e0+0.25e0*
    RAB[NP5-4])*Z;
  RAB[NP6-1] := (RAB[NP2-1]+0.5e0*RAB[NP3-2]+RAB[NP4-3]/3.e0+0.25e0*RAB[NP5-
    2-1])*Z;
  ID10E(DX,RAB,NP,3,1,NP-2,4,0,1,EPS,RAB[NP5+0],RAB,LA,IER1);
  if ( IER1  <> 0 ) 
   then BUL := True;
_8:
  X := XN;
  for KG:=1 to NP do
   begin
    F(RAB[NP8+KG-1],RAB[NP7+KG-1],RAB[NP6+KG-1],X,Y[KG-1],NP5+KG,RAB);
    X := X+DX;
_9:
   end;
_10:
  DE50E(NP,XN,XK,CN,CK,RAB[NP8+0],RAB[NP7+0],RAB[NP6+0],EPS,N5,
  Y,IK,DELTY,RAB,IERR);
  if ( IERR  <> 0 ) 
   then goto _20;
  for KD:=1 to NP do
   begin
    KD1 := NP10+KD;
    if ( Abs(Y[KD-1]-RAB[KD1-1])-EPS ) < 0
     then goto _11
     else if ( Abs(Y[KD-1]-RAB[KD1-1])-EPS ) > 0
           then goto _15
           else goto _11;
_11:
   end;
  if ( N5-IMAX ) < 0
   then goto _12
   else if ( N5-IMAX ) > 0
         then goto _18
         else goto _18;
_12:
  if ( JUMP=13 ) then goto _13 else
  if ( JUMP=16 ) then goto _16;
_13:
  N5 := -IMAX;
  for KE:=1 to NP do
   begin
    KE1 := KE+NP9;
    RAB[KE1-1] := Y[KE-1];
_14:
   end;
  NUM1 := KA;
  goto _10;
_15:
 end;
IERR := 1;
IK := -1;
goto _20;
_16:
IK := KA;
for KG:=1 to NP do
 begin
  DELTY[KG-1] := 0.0e0;
_17:
 end;
goto _20;
_18:
for KF:=1 to NP do
 begin
  KF1 := NP9+KF;
  DELTY[KF-1] := Y[KF-1]-RAB[KF1-1];
_19:
 end;
IK := NUM1;
_20:
if ( IERR  <= 64  ) and ( BUL ) 
 then IERR := IERR+2;
if ( IERR  <> 0 ) 
 then UTDE11(IERR,51);
end;

end.
