Unit id10e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, ID10EP_p, UTID11_p;

procedure id10e(H :Extended; var Y :Array of Extended; MU :Integer;
                NL :Integer; NS :Integer; NU :Integer; NO :Integer;
                LO :Integer; NTH :Integer; T :Extended;
                var A :Array of Extended; var E :Array of Extended;
                var LA :Integer; var IERR :Integer);

implementation

procedure id10e(H :Extended; var Y :Array of Extended; MU :Integer;
                NL :Integer; NS :Integer; NU :Integer; NO :Integer;
                LO :Integer; NTH :Integer; T :Extended;
                var A :Array of Extended; var E :Array of Extended;
                var LA :Integer; var IERR :Integer);
var
LC,NH,LOJ,K,K2,I,LB,J,IB,IC :Integer;
C :Extended;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26;
begin
_CID10D.elm1 := 0.0e0; //     ID10D   SO   ID10EP_p (  31.08.10)
IERR := 0;
NH := NS div 2;
LOJ := LO+1;
if ( NTH-2 ) < 0
 then goto _1
 else if ( NTH-2 ) > 0
       then goto _3
       else goto _2;
_1:
C := 0.5e0/H;
goto _4;
_2:
C := 1.0e0/(H*H);
goto _4;
_3:
IERR := 65;
goto _26;
_4:
K := 0;
K2 := NTH;
I := NL;
while ( I<=NU ) do
 begin
  A[I-1] := 0.0e0;
_5:
  inc(I,NS);
 end;
if ( NO-NTH ) < 0
 then goto _6
 else if ( NO-NTH ) > 0
       then goto _7
       else goto _7;
_6:
IERR := 66;
goto _26;
_7:
LB := NTH;
while ( LB<=NO ) do
 begin
  LA := LB;
  case NTH of
   1: goto _8;
   2: goto _9;
  end;
_8:
  case LOJ of
   1: goto _10;
   2: goto _11;
   3: goto _17;
  end;
_9:
  case LOJ of
   1: goto _10;
   2: goto _17;
   3: goto _11;
  end;
_10:
  J := LA;
  goto _18;
_11:
  if ( NS-1 ) < 0
   then goto _15
   else if ( NS-1 ) > 0
         then goto _15
         else goto _12;
_12:
  case NTH of
   1: goto _13;
   2: goto _14;
  end;
_13:
  IERR := 67;
  goto _26;
_14:
  IERR := 68;
  goto _26;
_15:
  case NTH of
   1: goto _17;
   2: goto _16;
  end;
_16:
  J := LA div 2+1;
  goto _18;
_17:
  J := (LA+1) div 2;
_18:
  case NTH of
   1: goto _19;
   2: goto _21;
  end;
_19:
  I := NL;
  while ( I<=NU ) do
   begin
    IB := I-NH;
    IC := IB+NS;
    E[I-1] := C*(Y[(IB-1)+(J+0)*MU]+Y[(IC-1)+(J+0)*MU]);
_20:
    inc(I,NS);
   end;
  goto _23;
_21:
  I := NL;
  while ( I<=NU ) do
   begin
    E[I-1] := C*Y[(I-1)+(J+0)*MU];
_22:
    inc(I,NS);
   end;
_23:
  ID10EP(A,T,E,LC,LA,NL,NS,NU,NO,NTH);
  if ( LC = 4 )
   then IERR := 2;
  if ( LC = 5 )
   then IERR := 3;
  if ( LC ) < 0
   then goto _26
   else if ( LC ) > 0
         then goto _26
         else goto _24;
_24:
  K := K+1;
  K2 := K2+2;
  C := -(K*K)*C/(K2)/((K2)-1.e0);
_25:
  inc(LB,2);
 end;
IERR := 1;
_26:
if ( IERR <> 0 )
 then UTID11(IERR,10);
end;

end.
